# Features

### Models

Call models such as GPT-4, ElevenLabs or Stable Diffusion in a single line.&#x20;

```
[prompt.generate_background]
model_name = stable-diffusion-xl
message = Background image. Light colors. {{user_input}}
```

PromptSpace is constantly adding new models and will support self-hosted models soon. Email <nico@promptspace.app> to request a model you need to create your UX.

### API Keys

PromptSpace provides the API keys--no more subscribing to waitlists.

### UI

Choose how to display the output of a block to the user.

```
display_option = image / video / markdown
```

The output of each block of displayed to the user as text by default. Hide the output of intermediate blocks.

```
display = False
```

### Output Validation

Assets that the output of a block conforms to a format.

```
output_type = json / ini / nlp
```

### Dependencies

Use the most popular Python dependencies including LangChain, Beautiful Soup and MoviePy without `requirements.txt` or reading the docs. PSL only exposes features useful for GenAI apps.

```
[prompt.read_page]
model_name = bsoup
description.url = Please paste a Wikipedia url:
url = {{url}}
output_type = nlp
display = False 

[prompt.question]
description.question = What would you like to ask?
message = {{response.read_page.ask(question)}}

```

### Concurrency

PromptSpace implements the job queues so you can focus on the UX of a single user.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.promptspace.app/features.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
